#ifndef _pthread_threadedexecutor_
#define _pthread_threadedexecutor_

#include "noncopyable.h"
#include "runnable.h"
#include <vector>

namespace PThread
{

class ThreadedExecutor:public NonCopyable
{
public:
	ThreadedExecutor()		{}
	~ThreadedExecutor();

	void Execute(Runnable *runnable);
	
	void Join();
	void Cancel();

private:
	void CleanupFinished();
	
	std::vector<Thread *> m_threads;
};

}

#endif	// _pthread_threadedexecutor_
